{"revision":"c10276e953456835cdbb1f3a60d58ae1980be353","document":{"id":500,"path":"api-reference/rest-apis/cs-catalog-api.md","title":"Cloud Services Catalog API","bundle":null,"doc_type":null,"release":"australia","body":"\n# Cloud Services Catalog API\n\nThe Cloud Services Catalog API provides methods related to Day-1 \\(provisioning\\) and Day-2 \\(modification\\) operations available in the Cloud Services Catalog, such as creating cloud service stacks and calling resource operation requests. You can also retrieve information about catalog requests, stacks getting status, and other information.\n\nThis API is included in the `now` namespace and requires the sn\\_cmp.cloud\\_service\\_user role. The Cloud Services Catalog \\(CSC\\) application is available as a separate subscription and requires either the ITOM Enterprise bundle or ITOM Cloud Accelerate product Entitlement.\n\nThe Cloud Services Catalog API features actions you perform during Day 2 operations. In the context of this API, resource catalog items refer to catalog items related to Day 2 operations.\n\nTo use this API, ensure that you have completed the Cloud Services Catalog guided setup process or have a working configuration where provisioning and catalog operations are working in the UI. For more information about these steps, see [Cloud Services Catalog](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-operations-management/csc-home.md).\n\n**Parent Topic:**[REST API reference](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/api-rest.md)\n\n## Cloud Services Catalog - GET /now/cmp\\_catalog\\_api/itemsbyciclass\n\nReturns a list of resource catalog items based on a given configuration item \\(CI\\) class.\n\n### URL format\n\nDefault URL: `/api/now/cmp_catalog_api/itemsbyciclass`\n\n### Supported request parameters\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nci\\_class\n\n</td><td>\n\nRequired. Name of the CI class to get the resource catalog items from \\(for example, \"cmdb\\_ci\\_vm\\_instance\"\\). Located in the Reference CI Type field in the Configuration Item \\[cmdb\\_ci\\] table.Data type: String\n\n</td></tr><tr><td>\n\ndisplay\\_variables\n\n</td><td>\n\nFlag that indicates whether to list catalog item variables associated with each catalog item.Valid values:\n\n-   true: Displays list catalog item variables.\n-   false: Doesn't display list catalog item variables.\n\nData type: Boolean\n\nDefault: False\n\n</td></tr><tr><td>\n\noperation\\_name\n\n</td><td>\n\nOptional. Name of the operation. Located in the Name column of the resource interface in the OperationSignature \\[sn\\_cmp\\_rb\\_op\\_signature\\] table.**Note:** This parameter can query part or whole of the operation. For example, if you want to list all interfaces starting with \"Servicenow\", you can set the variable as `operation_name = Servicenow`.\n\nDefault: All catalog items of all operation types are returned.\n\nData type: String\n\n</td></tr><tr><td>\n\nresource\\_interface\n\n</td><td>\n\nOptional. Resource interface that the resource catalog item is hosted on. Located in the Name column of the ResourceInterfaces \\[sn\\_cmp\\_rb\\_resourceinterface\\] table.Data type: String\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|401|Unauthorized. The user credentials are incorrect or have not been passed.|\n|403|Forbidden. The user doesn't have access rights to the specified record.|\n|404|Not found. The requested item wasn't found.|\n|405|Invalid method. The functionality is disabled.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters \\(JSON or XML\\)\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nactive\n\n</td><td>\n\nActive state of the resource operation catalog item. Possible values:\n\n-   true: The resource operation catalog item is active.\n-   false: The resource operation catalog item is inactive.\n\nData type: String\n\n</td></tr><tr><td>\n\ncreated\\_on\n\n</td><td>\n\nTime stamp from when the resource operation catalog item was created. Format: yyyy-MM-dd HH:mm:ss.\n\nData type: String\n\n</td></tr><tr><td>\n\ndisplay\\_name\n\n</td><td>\n\nName of the resource interface. Located in the ResourceInterfaces \\[sn\\_cmp\\_rb\\_resourceinterface\\] table.Data type: String\n\n</td></tr><tr><td>\n\nid\n\n</td><td>\n\nSys\\_id of the resource operation catalog item.Data type: String\n\nTable: Resource Operation Catalog Item \\[sn\\_cmp\\_rsrc\\_opr\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nname\n\n</td><td>\n\nName of the resource operation catalog item. Located in the Resource Operation Catalog Item \\[sn\\_cmp\\_rsrc\\_opr\\_cat\\_item\\] table.Data type: String\n\n</td></tr><tr><td>\n\nshort\\_description\n\n</td><td>\n\nBrief description of the resource operation catalog item.Data type: String\n\nTable: Resource Operation Catalog Item \\[sn\\_cmp\\_rsrc\\_opr\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nupdated\\_on\n\n</td><td>\n\nTime stamp from when the resource operation catalog item was last updated. Required format: yyyy-MM-dd HH:mm:ss.Data type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example requests and returns the status of the request item.\n\n```\ncurl \"https://instance.servicenow.com/api/now/cmp_catalog_api/itemsbyciclass?ci_class=cmdb_ci_vm_instance&resource_interface=Virtual%20Machine%20Store%20Extension%20Interface&operation_name=Execute%20Job%20Template\" \\\n--request GET \\ \n--header 'Accept: application/json' \\ \n--user 'username':'password'\n```\n\nResponse:\n\n```\n[\n  {\n    \"display_name\": \"Virtual Server-Virtual Machine Store Extension Interface-Execute Job Template\",\n    \"id\": \"01b2341a56789012345d6ddeeff7b89fc\",\n    \"created_on\": \"2019-04-28 12:58:26\",\n    \"updated_on\": \"2019-04-28 12:58:26\",\n    \"name\": \"Virtual Server-Virtual Machine Store Extension Interface-Execute Job Template\",\n    \"short_description\": \"Catalog item to invoke operation\",\n    \"active\": true\n  }\n]\n```\n\n## Cloud Services Catalog - GET /now/cmp\\_catalog\\_api/itemsbyrb\n\nReturns a list of resource catalog items based on a given resource block.\n\n### URL format\n\nDefault URL: `/api/now/cmp_catalog_api/itemsbyrb`\n\n### Supported request parameters\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ndisplay\\_variables\n\n</td><td>\n\nFlag that indicates whether to list catalog item variables associated with each catalog item.Valid values:\n\n-   true: Displays list catalog item variables.\n-   false: Doesn't display list catalog item variables.\n\nData type: Boolean\n\nDefault: False\n\n</td></tr><tr><td>\n\noperation\\_name\n\n</td><td>\n\nOptional. Name of the operation. Located in the Name column of the resource interface in the OperationSignature \\[sn\\_cmp\\_rb\\_op\\_signature\\] table.**Note:** This parameter can query part or whole of the operation. For example, if you want to list all interfaces starting with \"Servicenow\", you can set the variable as `operation_name = Servicenow`.\n\nDefault: All catalog items of all operation types are returned.\n\nData type: String\n\n</td></tr><tr><td>\n\nresource\\_block\n\n</td><td>\n\nRequired. Name of the resource block to get its related resource operation catalog items from \\(for example, Virtual Server\\).Default: All catalog items of all operation types are returned.\n\nData type: String\n\nTable: Resource Block \\[sn\\_cmp\\_rb\\_resourceblock\\]\n\n</td></tr><tr><td>\n\nresource\\_interface\n\n</td><td>\n\nOptional. Resource interface that the resource catalog item is hosted on. Located in the Name column of the ResourceInterfaces \\[sn\\_cmp\\_rb\\_resourceinterface\\] table.Data type: String\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|401|Unauthorized. The user credentials are incorrect or have not been passed.|\n|403|Forbidden. The user doesn't have access rights to the specified record.|\n|404|Not found. The requested item wasn't found.|\n|405|Invalid method. The functionality is disabled.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters \\(JSON or XML\\)\n\n<table id=\"table_dbv_lt3_1bc\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nactive\n\n</td><td>\n\nActive state of the resource operation catalog item. Possible values:\n\n-   true: The resource operation catalog item is active.\n-   false: The resource operation catalog item is inactive.\n\nData type: String\n\n</td></tr><tr><td>\n\ndisplay\\_name\n\n</td><td>\n\nName of the resource interface. Located in the ResourceInterfaces \\[sn\\_cmp\\_rb\\_resourceinterface\\] table.Data type: String\n\n</td></tr><tr><td>\n\nid\n\n</td><td>\n\nSys\\_id of the resource operation catalog item.Data type: String\n\nTable: Resource Operation Catalog Item \\[sn\\_cmp\\_rsrc\\_opr\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nname\n\n</td><td>\n\nName of the resource operation catalog item. Located in the Resource Operation Catalog Item \\[sn\\_cmp\\_rsrc\\_opr\\_cat\\_item\\] table.Data type: String\n\n</td></tr><tr><td>\n\nshort\\_description\n\n</td><td>\n\nBrief description of the resource operation catalog item.Data type: String\n\nTable: Resource Operation Catalog Item \\[sn\\_cmp\\_rsrc\\_opr\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nvariables\n\n</td><td>\n\nList of extra details about the resource catalog item. The variables returned in this API vary based on the query parameters that were passed.Data type: Array of Objects\n\n```\n\"variables\": [\n  {\n    \"parameter1\": \"String\",\n    \"parameter2\": \"String\"\n  }\n]\n```\n\n</td></tr></tbody>\n</table>This example list of resource catalog items based on a Virtual Server resource block:\n\n```\ncurl \"https://instance.servicenow.com/api/now/cmp_catalog_api/itemsbyrb?resource_interface=Virtual%20Machine%20Store%20Extension%20Interface&operation_name=Execute%20Job%20Template&resource_block=Virtual%20Server\" \\\n--request GET \\ \n--header 'Accept: application/json' \\ \n--user 'username':'password'\n```\n\nResponse:\n\n```\n[\n  {\n    \"display_name\": \"Virtual Server-Virtual Machine Store Extension Interface-Execute Job Template\",\n    \"id\": \"01b2341a56789012345d6ddeeff7b89fc\",\n    \"created_on\": \"2019-04-28 12:58:26\",\n    \"updated_on\": \"2019-04-28 12:58:26\",\n    \"name\": \"Virtual Server-Virtual Machine Store Extension Interface-Execute Job Template\",\n    \"short_description\": \"Catalog item to invoke operation\",\n    \"active\": true\n  }\n]\n```\n\n## Cloud Services Catalog - GET /now/cmp\\_catalog\\_api/services\n\nReturns a list of catalog items based on the given blueprint of a Provision or Lifecycle catalog type.\n\n### URL format\n\nDefault URL: `/api/now/cmp_catalog_api/services`\n\n### Supported request parameters\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncatalog\\_type\n\n</td><td>\n\nOptional. Type of catalog item. Accepted values \\(case-sensitive\\):-   `Provision` - Returns all Blueprint type catalog items.\n-   `LifeCycle` - Returns all Day 2 Operation type catalog items.\n\nIf the input is empty \\(default\\), all services of both catalog types are returned.\n\nData type: String\n\n</td></tr><tr><td>\n\ndisplay\\_variables\n\n</td><td>\n\nFlag that indicates whether to list catalog item variables associated with each catalog item.Valid values:\n\n-   true: Displays list catalog item variables.\n-   false: Doesn't display list catalog item variables.\n\nData type: Boolean\n\nDefault: False\n\n</td></tr><tr><td>\n\nblueprint\\_name\n\n</td><td>\n\nOptional. Name of the blueprint in which to fetch the related catalog items. Located in the Category Item \\[sn\\_cmp\\_bp\\_cat\\_item\\] table. **Note:** This parameter can query part or whole of the blueprint name. For example, if you want to list all blueprints starting with \"Servicenow\", you can set the variable as `blueprint_name = Servicenow`.\n\nDefault: all services of all blueprints are returned.\n\nData type: String\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|401|Unauthorized. The user credentials are incorrect or have not been passed.|\n|403|Forbidden. The user doesn't have access rights to the specified record.|\n|404|Not found. The requested item wasn't found.|\n|405|Invalid method. The functionality is disabled.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters \\(JSON or XML\\)\n\n<table id=\"table_mqx_4y3_1bc\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nactive\n\n</td><td>\n\nFlag that indicates whether the catalog is active. Possible values:\n\n-   true: Catalog is active.\n-   false: Catalog isn't active.\n\nData type: String\n\n</td></tr><tr><td>\n\nblueprint\n\n</td><td>\n\nSys\\_id of the blueprint.Data type: String\n\nTable: Blueprint \\[sn\\_cmp\\_bp\\_blueprint\\]\n\n</td></tr><tr><td>\n\nblueprint\\_category\n\n</td><td>\n\nSys\\_id of the blueprint category.Data type: String\n\nTable: Cloud Service Category \\[sn\\_capi\\_service\\_category\\]\n\n</td></tr><tr><td>\n\nblueprint\\_category\\_name\n\n</td><td>\n\nName of the blueprint category. Possible values:\n\n-   Access\n-   Analytics\n-   Application Services\n-   Blockchain\n-   Business Productivity\n-   Compute\n-   Config Management\n-   Containers\n-   Database\n-   Developer Tools\n-   Event\n-   Hybrid Cloud\n-   IOT\n-   IPAM\n-   Loud Balancer\n-   Machine Learning\n-   Management Tools\n-   Marketplace\n-   Mobile\n-   Network\n-   Productivity\n-   Security\n-   Shell Access\n-   Storage\n-   Tools\n-   Unknown\n-   Virtual Reality\n\nData type: String\n\nTable:Cloud Service Category \\[sn\\_capi\\_service\\_category\\]\n\n</td></tr><tr><td>\n\nblueprint\\_name\n\n</td><td>\n\nName of the blueprint. Located in the Blueprint \\[sn\\_cmp\\_bp\\_blueprint\\] table.Data type: String\n\n</td></tr><tr><td>\n\nblueprint\\_type\n\n</td><td>\n\nType of blueprint. Possible value: `Custom Blueprint`\n\nData type: String\n\n</td></tr><tr><td>\n\ncatalog\\_name\n\n</td><td>\n\nName of the catalog.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\ncatalog\\_type\n\n</td><td>\n\nType of catalog. Possible values:\n\n-   `1`: Catalog is of type provision.\n-   `2`: Catalog is of type lifecycle.\n\nData type: String\n\n</td></tr><tr><td>\n\ncatalog\\_type\n\n</td><td>\n\nType of catalog. Possible values:\n\n-   `1`: Catalog is of type provision.\n-   `2`: Catalog is of type lifecycle.\n\nData type: String\n\n</td></tr><tr><td>\n\ncreatedOn\n\n</td><td>\n\nTime stamp from when the catalog item was created. Data type: String\n\n</td></tr><tr><td>\n\ncreatedBy\n\n</td><td>\n\nUser that created the catalog item.Data type: String\n\n</td></tr><tr><td>\n\nid\n\n</td><td>\n\nSys\\_id of the blueprint.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nlast\\_updated\\_on\n\n</td><td>\n\nTime stamp from when the catalog item was last updated. Data type: String\n\n</td></tr><tr><td>\n\nlast\\_updated\\_by\n\n</td><td>\n\nUser that last updated the catalog item, such as an admin or the system. Data type: String\n\n</td></tr><tr><td>\n\noperation\n\n</td><td>\n\nSys\\_id of the operation.Data type: String\n\nTable: OperationSignature \\[sn\\_cmp\\_rb\\_op\\_signature\\]\n\n</td></tr><tr><td>\n\noperation\\_name\n\n</td><td>\n\nName of the operation. Possible values:\n\n-   Deprovision: Deletes resources with a terminated state and updates resource CMDB tables accordingly.\n-   ModifyLease: Modifies the lease operation scheduled on provisioned resources.\n-   ModifySchedule: Modifies the schedule for provisioned resources.\n-   Start: Starts the resources that are in an off state.\n-   Stop: Stops the resources that are in an on state.\n\nData type: String\n\n</td></tr><tr><td>\n\nvariables\n\n</td><td>\n\nDetails about the list catalog item. The variables returned in this API vary based on the query parameters that are passed in the request.Data type: Array of Objects\n\n```\n\"variables\": [\n  {\n    \"parameter1\": \"String\",\n    \"parameter2\": \"String\"\n  }\n]\n```\n\n</td></tr></tbody>\n</table>This example returns all the catalog items of a Lifecycle type blueprint named \"classiclb\".\n\n```\ncurl \"https://instance.servicenow.comapi/now/cmp_catalog_api/services?display_variables=true&catalog_type=LifeCycle&blueprint_name=classiclb\" \\\n--request GET \\ \n--header 'Accept: application/json' \\ \n--user 'username':'password'\n```\n\nResponse:\n\n```\n[\n  {\n    \"catalog_name\": \"Deprovision\",\n    \"blueprint\": \"d90d9d80476c46104bf15222516d43b9\",\n    \"blueprint_name\": \"classiclb\",\n    \"blueprint_category\": \"57c0dbd9934b22004a9032bfa67ffb79\",\n    \"active\": true,\n    \"category\": \"86d85478678232005ca552e457415a79\",\n    \"blueprint_category_name\": \"Compute\",\n    \"shortDescription\": \"Are you sure you want to perform this operation?\",\n    \"id\": \"01b2341a56789012345d6ddeeff7b89fc\",\n    \"variables\": [\n      {\n        \"id\": \"a12d34c5678c91234bf45678912d34e4\",\n        \"name\": \"StackID\",\n        \"question_text\": \"StackID\",\n        \"default_value\": \"Not specified\"\n      }\n    ],\n    \"last_updated_on\": \"2024-02-19 07:46:03\",\n    \"last_updated_by\": \"system\",\n    \"catalog_type\": \"2\",\n    \"created_on\": \"2024-02-19 07:46:02\",\n    \"created_by\": \"user@password.com\",\n    \"operation\": \"a70d51c0476c46104bf15222516d4375\",\n    \"blueprint_type\": \"Custom Blueprint\",\n    \"operation_name\": \"Deprovision\"\n  },\n  {\n    \"catalog_name\": \"ModifySchedule\",\n    \"blueprint\": \"d90d9d80476c46104bf15222516d43b9\",\n    \"blueprint_name\": \"classiclb\",\n    \"blueprint_category\": \"57c0dbd9934b22004a9032bfa67ffb79\",\n    \"active\": true,\n    \"category\": \"86d85478678232005ca552e457415a79\",\n    \"blueprint_category_name\": \"Compute\",\n    \"shortDescription\": null,\n    \"id\": \"361d55c0476c46104bf15222516d4351\",\n    \"variables\": [\n      {\n        \"id\": \"031d55c0476c46104bf15222516d43af\",\n        \"name\": \"ScheduleProfile\",\n        \"question_text\": \"ScheduleProfile\",\n        \"default_value\": \"Not specified\"\n      },\n      {\n        \"id\": \"0b1d55c0476c46104bf15222516d43c9\",\n        \"name\": \"ScheduleTimeZone\",\n        \"question_text\": \"ScheduleTimeZone\",\n        \"default_value\": \"Not specified\"\n      }\n    ],\n    \"last_updated_on\": \"2024-02-19 07:45:53\",\n    \"last_updated_by\": \"system\",\n    \"catalog_type\": \"2\",\n    \"created_on\": \"2024-02-19 07:45:52\",\n    \"created_by\": \"user@password.com\",\n    \"operation\": \"130d51c0476c46104bf15222516d436c\",\n    \"blueprint_type\": \"Custom Blueprint\",\n    \"operation_name\": \"ModifySchedule\"\n  },\n  {\n    \"catalog_name\": \"Stop\",\n    \"blueprint\": \"d90d9d80476c46104bf15222516d43b9\",\n    \"blueprint_name\": \"classiclb\",\n    \"blueprint_category\": \"57c0dbd9934b22004a9032bfa67ffb79\",\n    \"active\": true,\n    \"category\": \"86d85478678232005ca552e457415a79\",\n    \"blueprint_category_name\": \"Compute\",\n    \"shortDescription\": \"Are you sure you want to perform this operation?\",\n    \"id\": \"542dd5c0476c46104bf15222516d43b0\",\n    \"variables\": [\n      {\n        \"id\": \"a02d19c0476c46104bf15222516d4301\",\n        \"name\": \"StackID\",\n        \"question_text\": \"StackID\",\n        \"default_value\": \"Not specified\"\n      }\n    ],\n    \"last_updated_on\": \"2024-02-19 07:46:00\",\n    \"last_updated_by\": \"system\",\n    \"catalog_type\": \"2\",\n    \"created_on\": \"2024-02-19 07:45:58\",\n    \"created_by\": \"user@password.com\",\n    \"operation\": \"930d51c0476c46104bf15222516d436f\",\n    \"blueprint_type\": \"Custom Blueprint\",\n    \"operation_name\": \"Stop\"\n  },\n  {\n    \"catalog_name\": \"Cleanup\",\n    \"blueprint\": \"d90d9d80476c46104bf15222516d43b9\",\n    \"blueprint_name\": \"classiclb\",\n    \"blueprint_category\": \"57c0dbd9934b22004a9032bfa67ffb79\",\n    \"active\": true,\n    \"category\": \"86d85478678232005ca552e457415a79\",\n    \"blueprint_category_name\": \"Compute\",\n    \"shortDescription\": \"Are you sure you want to perform this operation?\",\n    \"id\": \"712d59c0476c46104bf15222516d435c\",\n    \"variables\": [\n      {\n        \"id\": \"da2d59c0476c46104bf15222516d43dc\",\n        \"name\": \"resourceId\",\n        \"question_text\": \"ResourceId\",\n        \"default_value\": \"Not specified\"\n      },\n      {\n        \"id\": \"da2d59c0476c46104bf15222516d43e2\",\n        \"name\": \"operationName\",\n        \"question_text\": \"OperationName\",\n        \"default_value\": \"Not specified\"\n      }\n    ],\n    \"last_updated_on\": \"2024-02-19 07:46:06\",\n    \"last_updated_by\": \"system\",\n    \"catalog_type\": \"2\",\n    \"created_on\": \"2024-02-19 07:46:04\",\n    \"created_by\": \"user@password.com\",\n    \"operation\": \"ab0d51c0476c46104bf15222516d437b\",\n    \"blueprint_type\": \"Custom Blueprint\",\n    \"operation_name\": \"Cleanup\"\n  },\n  {\n    \"catalog_name\": \"ModifyLease\",\n    \"blueprint\": \"d90d9d80476c46104bf15222516d43b9\",\n    \"blueprint_name\": \"classiclb\",\n    \"blueprint_category\": \"57c0dbd9934b22004a9032bfa67ffb79\",\n    \"active\": true,\n    \"category\": \"86d85478678232005ca552e457415a79\",\n    \"blueprint_category_name\": \"Compute\",\n    \"shortDescription\": null,\n    \"id\": \"bb1dd5c0476c46104bf15222516d4301\",\n    \"variables\": [\n      {\n        \"id\": \"142dd5c0476c46104bf15222516d4382\",\n        \"name\": \"resourceId\",\n        \"question_text\": \"ResourceId\",\n        \"default_value\": \"Not specified\"\n      },\n      {\n        \"id\": \"d82dd5c0476c46104bf15222516d4394\",\n        \"name\": \"operationName\",\n        \"question_text\": \"OperationName\",\n        \"default_value\": \"Not specified\"\n      }\n    ],\n    \"last_updated_on\": \"2024-02-19 07:45:58\",\n    \"last_updated_by\": \"system\",\n    \"catalog_type\": \"2\",\n    \"created_on\": \"2024-02-19 07:45:56\",\n    \"created_by\": \"user@password.com\",\n    \"operation\": \"2b0d51c0476c46104bf15222516d4378\",\n    \"blueprint_type\": \"Custom Blueprint\",\n    \"operation_name\": \"ModifyLease\"\n  },\n  {\n    \"catalog_name\": \"Start\",\n    \"blueprint\": \"d90d9d80476c46104bf15222516d43b9\",\n    \"blueprint_name\": \"classiclb\",\n    \"blueprint_category\": \"57c0dbd9934b22004a9032bfa67ffb79\",\n    \"active\": true,\n    \"category\": \"86d85478678232005ca552e457415a79\",\n    \"blueprint_category_name\": \"Compute\",\n    \"shortDescription\": \"Are you sure you want to perform this operation?\",\n    \"id\": \"d71d95c0476c46104bf15222516d4312\",\n    \"variables\": [\n      {\n        \"id\": \"731d95c0476c46104bf15222516d43ae\",\n        \"name\": \"resourceId\",\n        \"question_text\": \"ResourceId\",\n        \"default_value\": \"Not specified\"\n      },\n      {\n        \"id\": \"731d95c0476c46104bf15222516d43b4\",\n        \"name\": \"operationName\",\n        \"question_text\": \"OperationName\",\n        \"default_value\": \"Not specified\"\n      }\n    ],\n    \"last_updated_on\": \"2024-02-19 07:45:55\",\n    \"last_updated_by\": \"system\",\n    \"catalog_type\": \"2\",\n    \"created_on\": \"2024-02-19 07:45:54\",\n    \"created_by\": \"user@password.com\",\n    \"operation\": \"270d51c0476c46104bf15222516d4372\",\n    \"blueprint_type\": \"Custom Blueprint\",\n    \"operation_name\": \"Start\"\n  }\n]\n```\n\n## Cloud Services Catalog - GET /now/cmp\\_catalog\\_api/stacks\n\nReturns a list of catalog items based on Provision-type blueprints \\(also known as stacks\\).\n\n### URL format\n\nDefault URL: `/api/now/cmp_catalog_api/stacks`\n\n### Supported request parameters\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nblueprint\\_name\n\n</td><td>\n\nOptional. Name of the blueprint in which to fetch the related catalog items. Located in the Category Item \\[sn\\_cmp\\_bp\\_cat\\_item\\] table. **Note:** This parameter can query part or whole of the blueprint name. For example, if you want to list all blueprints starting with \"Servicenow\", you can set the variable as `blueprint_name = Servicenow`.\n\nDefault: all services of all blueprints are returned.\n\nData type: String\n\n</td></tr><tr><td>\n\ndisplay\\_variables\n\n</td><td>\n\nFlag that indicates whether to list catalog item variables associated with each catalog item.Valid values:\n\n-   true: Displays list catalog item variables.\n-   false: Doesn't display list catalog item variables.\n\nData type: Boolean\n\nDefault: False\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|401|Unauthorized. The user credentials are incorrect or have not been passed.|\n|403|Forbidden. The user doesn't have access rights to the specified record.|\n|404|Not found. The requested item wasn't found.|\n|405|Invalid method. The functionality is disabled.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters \\(JSON or XML\\)\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nactive\n\n</td><td>\n\nFlag that indicates whether the catalog is active. Possible values:\n\n-   true: Catalog is active.\n-   false: Catalog isn't active.\n\nData type: String\n\n</td></tr><tr><td>\n\nblueprint\n\n</td><td>\n\nSys\\_id of the blueprint.Data type: String\n\nTable: Blueprint \\[sn\\_cmp\\_bp\\_blueprint\\]\n\n</td></tr><tr><td>\n\nblueprint\\_category\n\n</td><td>\n\nSys\\_id of the blueprint category.Data type: String\n\nTable: Cloud Service Category \\[sn\\_capi\\_service\\_category\\]\n\n</td></tr><tr><td>\n\nblueprint\\_category\\_name\n\n</td><td>\n\nName of the blueprint category. Possible values:\n\n-   Access\n-   Analytics\n-   Application Services\n-   Blockchain\n-   Business Productivity\n-   Compute\n-   Config Management\n-   Containers\n-   Database\n-   Developer Tools\n-   Event\n-   Hybrid Cloud\n-   IOT\n-   IPAM\n-   Loud Balancer\n-   Machine Learning\n-   Management Tools\n-   Marketplace\n-   Mobile\n-   Network\n-   Productivity\n-   Security\n-   Shell Access\n-   Storage\n-   Tools\n-   Unknown\n-   Virtual Reality\n\nData type: String\n\nTable:Cloud Service Category \\[sn\\_capi\\_service\\_category\\]\n\n</td></tr><tr><td>\n\nblueprint\\_name\n\n</td><td>\n\nName of the blueprint. Located in the Blueprint \\[sn\\_cmp\\_bp\\_blueprint\\] table.Data type: String\n\n</td></tr><tr><td>\n\nblueprint\\_type\n\n</td><td>\n\nType of blueprint. Possible value: `Custom Blueprint`\n\nData type: String\n\n</td></tr><tr><td>\n\ncatalog\\_name\n\n</td><td>\n\nName of the catalog.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\ncatalog\\_type\n\n</td><td>\n\nType of catalog. Possible values:\n\n-   `1`: Catalog is of type provision.\n-   `2`: Catalog is of type lifecycle.\n\nData type: String\n\n</td></tr><tr><td>\n\ncatalog\\_type\\_name\n\n</td><td>\n\nName of the catalog type.Possible values:\n\n-   Provision Operation \\(Day 1\\): Catalog type is named provision.\n-   LifeCycle Operation \\(Day 2\\): Catalog type is named lifecycle.\n\nData type: String\n\n</td></tr><tr><td>\n\nid\n\n</td><td>\n\nSys\\_id of the blueprint.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nlifecycleOperations\n\n</td><td>\n\nObject containing the life cycle operation's name and sys\\_id.Date type: Array of Objects\n\n```\n\"lifecycleOperations\": [\n      {\n        \"id\": \"String\",\n        \"name\": \"String\"\n      }\n```\n\n</td></tr><tr><td>\n\nlifecycleOperations.id\n\n</td><td>\n\nSys\\_id of the life cycle operation.Data type: String\n\nTable: OperationSignature \\[sn\\_cmp\\_rb\\_op\\_signature\\]\n\n</td></tr><tr><td>\n\nlifeCycleOperations.name\n\n</td><td>\n\nType of life cycle operations. Possible values:\n\n-   Cleanup: Cleans up resources with a terminated state.\n-   Deprovision: Deletes resources in a terminated state and updates resource CMDB tables accordingly.\n-   ModifyLease: Modifies the lease operation scheduled on provisioned resources.\n-   ModifySchedule: Performs business hours scheduling on stacks at the time of provisioning or on existing stacks.\n-   Start: Starts the resources that are in an off state.\n-   Stop: Stops the resources that are in an on state.\n\nDate type: Object\n\n</td></tr><tr><td>\n\noperation\n\n</td><td>\n\nSys\\_id of the operation.Data type: String\n\nTable: OperationSignature \\[sn\\_cmp\\_rb\\_op\\_signature\\]\n\n</td></tr><tr><td>\n\noperation\\_name\n\n</td><td>\n\nName of the operation. Possible values:\n\n-   Deprovision: Deletes resources with a terminated state and updates resource CMDB tables accordingly.\n-   ModifyLease: Modifies the lease operation scheduled on provisioned resources.\n-   ModifySchedule: Modifies the schedule for provisioned resources.\n-   Start: Starts the resources that are in an off state.\n-   Stop: Stops the resources that are in an on state.\n\nData type: String\n\n</td></tr><tr><td>\n\nshortDescription\n\n</td><td>\n\nBrief description of the catalog.Data type: String\n\n</td></tr><tr><td>\n\ntemplate\\_name\n\n</td><td>\n\nName of the template.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\ntemplate\\_type\n\n</td><td>\n\nSys\\_id of the template type.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\ntemplate\\_cloud\\_product\\_name\n\n</td><td>\n\nName of the product.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nvariables\n\n</td><td>\n\nDetails about the list catalog item. The variables returned in this API vary based on the query parameters that are passed in the request.Data type: Array of Objects\n\n```\n\"variables\": [\n  {\n    \"parameter1\": \"String\",\n    \"parameter2\": \"String\"\n  }\n]\n```\n\n</td></tr></tbody>\n</table>The following example returns all catalog items in the instance with the provision catalog type.\n\n```\ncurl \"https://instance.servicenow.com/api/now/cmp_catalog_api/stacks\" \\\n--request GET \\ \n--header 'Accept: application/json' \\ \n--user 'username':'password'\n```\n\nReturn:\n\n```\n[\n  {\n    \"catalog_type\": \"1\",\n    \"catalog_type_name\": \"Provision Operation (Day 1)\",\n    \"catalog_name\": \"classiclb\",\n    \"blueprint\": \"d90d9d80476c46104bf15222516d43b9\",\n    \"blueprint_name\": \"classiclb\",\n    \"blueprint_category\": \"57c0dbd9934b22004a9032bfa67ffb79\",\n    \"blueprint_category_name\": \"Compute\",\n    \"active\": true,\n    \"category\": \"8641fe260b212200eff7ef9bb4673a3d\",\n    \"shortDescription\": null,\n    \"id\": \"07cc9580476c46104bf15222516d43c3\",\n    \"last_updated_on\": \"2024-02-19 07:46:13\",\n    \"last_updated_by\": \"user@servicenow.com\",\n    \"blueprint_type\": \"Cloud Template\",\n    \"template_type\": \"932f81e49f00320048111f80a57fcf6e\",\n    \"template_name\": \"CloudFormation Template\",\n    \"template_cloud_product\": \"52cfc4749f00320048111f80a57fcf9a\",\n    \"template_cloud_product_name\": \"AWS CloudFormation\",\n    \"lifecycleOperations\": [\n      {\n        \"id\": \"1d2d19c0476c46104bf15222516d4392\",\n        \"name\": \"Deprovision\"\n      },\n      {\n        \"id\": \"361d55c0476c46104bf15222516d4351\",\n        \"name\": \"ModifySchedule\"\n      },\n      {\n        \"id\": \"542dd5c0476c46104bf15222516d43b0\",\n        \"name\": \"Stop\"\n      },\n      {\n        \"id\": \"712d59c0476c46104bf15222516d435c\",\n        \"name\": \"Cleanup\"\n      },\n      {\n        \"id\": \"bb1dd5c0476c46104bf15222516d4301\",\n        \"name\": \"ModifyLease\"\n      },\n      {\n        \"id\": \"d71d95c0476c46104bf15222516d4312\",\n        \"name\": \"Start\"\n      }\n    ],\n    \"created_on\": \"2024-02-19 07:44:44\",\n    \"created_by\": \"user@servicenow.com\",\n    \"operation\": \"130d51c0476c46104bf15222516d4368\",\n    \"operation_name\": \"Provision\"\n  }\n]\n```\n\n## Cloud Services Catalog - GET /now/cmp\\_catalog\\_api/status\n\nReturns the status and details of a given catalog RITM \\(request item\\).\n\nUse this method to identify and trace the request's origin and monitor its flow. The response includes the following:\n\n1.  RITM number for the submitted request\n2.  The stage the request is in\n3.  The users who opened and is assigned the request\n4.  The group assigned to the request\n5.  When the request was opened\n6.  The state the request is in\n7.  Submission data\n\n### URL format\n\nDefault URL: `/api/now/cmp_catalog_api/status`\n\n### Supported request parameters\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nreq\\_item\n\n</td><td>\n\nUnique request item number in the Requested Item \\[sc\\_req\\_item\\] table. For example, `RITM0000001`.Data type: String\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|401|Unauthorized. The user credentials are incorrect or have not been passed.|\n|403|Forbidden. The user doesn't have access rights to the specified record.|\n|404|Not found. The requested item wasn't found.|\n|405|Invalid method. The functionality is disabled.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters \\(JSON or XML\\)\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nassignmentGroup\n\n</td><td>\n\nGroup assigned to the request.Data type: String\n\n</td></tr><tr><td>\n\nassignedTo\n\n</td><td>\n\nUser email assigned to the request.Data type: String\n\n</td></tr><tr><td>\n\ncatItem\n\n</td><td>\n\nSys\\_id of the catalog item request.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nMessage with details about a returned error. Possible error messages:\n\n-   Record Not Found: The request item doesn't exist.\n-   User Not Authenticated: The user's credentials aren't authorized to make this request.\n\nData type: String\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique Request Item Number \\(RITM\\) given to the new request item.Data type: String\n\nTable: Request Item \\[sc\\_req\\_item\\]\n\n</td></tr><tr><td>\n\nopenedAt\n\n</td><td>\n\nTime stamp from when the request item was opened. Format: yyyy-MM-dd HH:mm:ss.\n\nDate type: String\n\n</td></tr><tr><td>\n\nopenedBy\n\n</td><td>\n\nSys\\_id of the user who opened the request.Data type: String\n\n</td></tr><tr><td>\n\nstage\n\n</td><td>\n\nCurrent processing stage of the request item. Possible values:\n\n-   Deploying Stack\n-   Deployment Cancelled\n-   Deployment Failed\n-   Deployment Successful\n-   Resource Limit Exceeded\n-   Retrying Stack Deployment\n-   Task Created for User\n-   Waiting for Provision Approval\n\nData type: String\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nCurrent completion state of the request item.Possible values:\n\n-   Closed Complete\n-   Closed Incomplete\n-   Closed Skipped\n-   Open\n-   Pending\n-   Work in Progress\n\nData type: String\n\n</td></tr><tr><td>\n\nsubmissionData\n\n</td><td>\n\nInformation about the request submission, like cloud account, location, application, and cost center data. Submission data varies depending on the request item number passed in the request.Data type: Object\n\n```\n\"submissionData\": \"{\\\"key1\\\":\\\"value\\\", \\\"key2\\\":\\\"value\\\"}\"\n}\n```\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the request item record.Data type: String\n\nTable: Request Item \\[sc\\_req\\_item\\]\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example returns status information for the request item number, RITM0010076.\n\n```\ncurl \"https://instance.servicenow.com/api/now/cmp_catalog_api/statusreq_item=RITM0010076\" \\\n--request GET \\ \n--header 'Accept: application/json' \\ \n--user 'username':'password'\n```\n\nResponse:\n\n```\n{ \n  \"catItem\": \"39737024c390719005091d75e0013115\", \n  \"stage\": \"Task Created for User\", \n  \"sys_id\": \"ee1197db476cc2904bf15222516d439f\", \n  \"assignedTo\": null, \n  \"assignmentGroup\": null, \n  \"number\": \"RITM0010072\", \n  \"openedAt\": \"2024-02-29 18:32:55\", \n  \"openedBy\": \"6816f79cc0a8016401c5a33be04be441\", \n  \"state\": \"Open\", \n  \"submissionData\": \"{\\\"CloudAccount\\\":\\\"AzureCA\\\",\\\"CSC_Azure_Functions_newResourceGroup\\\":\\\"test-rg-dnd\\\",\\\"CSC_Azure_Functions_runTimeVersion\\\":\\\"~18\\\",\\\"CSC_Azure_Functions_runTimeEngine\\\":\\\"node\\\",\\\"CSC_Azure_Functions_os\\\":\\\"Windows\\\",\\\"CSC_Azure_Functions_functionAppName\\\":\\\"sa02291029-fa\\\",\\\"LeaseEndDate\\\":\\\"2024-05-29 17:29:57\\\",\\\"ScheduleProfile\\\":\\\"-- No Schedule --\\\",\\\"UserGroup\\\":\\\"cfcbad03d711110050f5edcb9e61038f\\\",\\\"CSC_Azure_Functions_applicationName\\\":\\\"function-app\\\",\\\"ScheduleTimeZone\\\":\\\"America/Los_Angeles\\\",\\\"BusinessService\\\":\\\"\\\",\\\"environment\\\":\\\"Production\\\",\\\"CostCenter\\\":\\\"\\\",\\\"UseExistingWorkspace\\\":false,\\\"CSC_Azure_Functions_existingResourceGroup\\\":\\\"cpg-dnd\\\",\\\"CSC_Azure_Functions_isNewResourceGroup\\\":\\\"false\\\",\\\"CSC_Azure_Functions_storageAccountName\\\":\\\"sa02291029fasa\\\",\\\"Application\\\":\\\"\\\",\\\"StackName\\\":\\\"sa02291029\\\",\\\"Location\\\":\\\"Azure Datacenter - eastus\\\",\\\"Workspace\\\":\\\"\\\"}\" \n}\n```\n\n## Cloud Services Catalog - POST /now/cmp\\_catalog\\_api/submitoprequest\n\nSubmits a resource operation request to perform day 2 operations on provisioned resources.\n\n### URL format\n\nDefault URL: `/api/now/cmp_catalog_api/submitoprequest`\n\n### Supported request parameters\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n<table id=\"table_urr_lqw_cbc\" class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncat\\_id\n\n</td><td>\n\nRequired. sys\\_id of the cloud catalog item to invoke. Available in the Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\] table.Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_request_body\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nCloudAccount\n\n</td><td>\n\nRequired. Name of the cloud account in which to submit the request. Account names are available in the Cloud Account \\[cmdb\\_ci\\_cmp\\_cloud\\_account\\] table.Data type: String\n\n</td></tr><tr><td>\n\nLocation\n\n</td><td>\n\nRequired. Datacenter location in which to provision the resource. For example, `us-west-1` or `asia-south-2`. This value should match the datacenter location of the cloud account's platform provider. Available in the Associated Datacenter \\[sn\\_cmp\\_ca\\_assc\\_datacenter\\] table. Data type: String\n\n</td></tr><tr><td>\n\nStackName\n\n</td><td>\n\nRequired. Name of the stack. The stack name is dynamic and is reflected in resource management.Data type: String\n\n</td></tr><tr><td>\n\nresourceId\n\n</td><td>\n\nRequired. Sys\\_id of the resource where Day 2 operations will be performed.Data type: String\n\nTable: Stack Items \\[sn\\_cmp\\_stack\\_item\\]\n\n</td></tr><tr><td>\n\nresource\\_block\n\n</td><td>\n\nRequired. Name of the resource block to get its related resource operation catalog items from \\(for example, Virtual Server\\).Default: All catalog items of all operation types are returned.\n\nData type: String\n\nTable: Resource Block \\[sn\\_cmp\\_rb\\_resourceblock\\]\n\n</td></tr><tr><td>\n\noperation\\_name\n\n</td><td>\n\nOptional. Name of the operation. Located in the Name column of the resource interface in the OperationSignature \\[sn\\_cmp\\_rb\\_op\\_signature\\] table. The operation name you enter depends on the value passed in the **resourceBlock** parameter.**Note:** This parameter can query part or whole of the operation. For example, if you want to list all interfaces starting with \"Servicenow\", you can set the variable as `operation_name = Servicenow`.\n\nDefault: All catalog items of all operation types are returned.Data type: String\n\n</td></tr><tr><td>\n\nresourceInterface\n\n</td><td>\n\nRequired. Name of the resource block to get its related resource operation catalog items from \\(for example, Virtual Server\\). The resource interface you enter depends on the value passed in the **resourceBlock** and **operation\\_name** parameters.Default: All catalog items of all operation types are returned.\n\nData type: String\n\n</td></tr></tbody>\n</table>### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|401|Unauthorized. The user credentials are incorrect or have not been passed.|\n|403|Forbidden. The user doesn't have access rights to the specified record.|\n|404|Not found. The requested item wasn't found.|\n|405|Invalid method. The functionality is disabled.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters \\(JSON or XML\\)\n\n<table id=\"table_m3n_ndj_1bc\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nassignmentGroup\n\n</td><td>\n\nGroup assigned to the request.Data type: String\n\n</td></tr><tr><td>\n\nassignedTo\n\n</td><td>\n\nUser email assigned to the request.Data type: String\n\n</td></tr><tr><td>\n\ncatItem\n\n</td><td>\n\nSys\\_id of the catalog item request.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique Request Item Number \\(RITM\\) given to the new request item.Data type: String\n\nTable: Request Item \\[sc\\_req\\_item\\]\n\n</td></tr><tr><td>\n\nopenedAt\n\n</td><td>\n\nTime stamp from when the request item was opened. Format: yyyy-MM-dd HH:mm:ss.\n\nDate type: String\n\n</td></tr><tr><td>\n\nopenedBy\n\n</td><td>\n\nSys\\_id of the user who opened the request.Data type: String\n\n</td></tr><tr><td>\n\nstage\n\n</td><td>\n\nCurrent processing stage of the request item. Possible values:\n\n-   Deploying Stack\n-   Deployment Cancelled\n-   Deployment Failed\n-   Deployment Successful\n-   Resource Limit Exceeded\n-   Retrying Stack Deployment\n-   Task Created for User\n-   Waiting for Provision Approval\n\nData type: String\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nCurrent completion state of the request item.Possible values:\n\n-   Closed Complete\n-   Closed Incomplete\n-   Closed Skipped\n-   Open\n-   Pending\n-   Work in Progress\n\nData type: String\n\n</td></tr><tr><td>\n\nsubmissionData\n\n</td><td>\n\nInformation about the request submission, like cloud account, location, application, and cost center data. Submission data varies depending on the request item number passed in the request.Data type: Object\n\n```\n\"submissionData\": \"{\\\"key1\\\":\\\"value\\\", \\\"key2\\\":\\\"value\\\"}\"\n}\n```\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the request item record.Data type: String\n\nTable: Request Item \\[sc\\_req\\_item\\]\n\n</td></tr></tbody>\n</table>The following example creates a Day 2 operation request item.\n\n```\ncurl \"https://instance.servicenow.com/api/now/cmp_catalog_api/submitoprequest?cat_id=e44dcd238731e5101126cbb4dabb3506\" /\n--request POST\\ \n--header 'Accept: application/json' \\ \n--user 'username':'password'\n\n//Request body:\n{\"StackName\":\"sa02292143\",\"CloudAccount\":\"AWS\",\"Location\":\"AWS Datacenter - us-east-1\",\"resourceId\":\"df8c61e3eb2cc210d298fbbdbad0cd74\",\"operationName\":\"Deprovision\",\"resourceInterface\":\"S3 Interface\",\"resourceBlock\":\"S3\"}\n```\n\nResponse body:\n\n```\n{ \n  \"number\": \"RITM0010078\", \n  \"catItem\": \"e44dcd238731e5101126cbb4dabb3506\", \n  \"stage\": \"request_approved\", \n  \"sys_id\": \"9bf5cab3c3594610bc89b33605013190\", \n  \"assignedTo\": null, \n  \"assignmentGroup\": null, \n  \"openedAt\": \"2024-04-08 09:08:47\", \n  \"openedBy\": \"6816f79cc0a8016401c5a33be04be441\", \n  \"state\": \"Open\", \n  \"submissionData\": \"{\\\"StackName\\\":\\\"sa02292143\\\",\\\"CloudAccount\\\":\\\"AWS\\\",\\\"Location\\\":\\\"AWS Datacenter - us-east-1\\\",\\\"resourceId\\\":\\\"df8c61e3eb2cc210d298fbbdbad0cd74\\\",\\\"operationName\\\":\\\"Deprovision\\\",\\\"resourceInterface\\\":\\\"S3 Interface\\\",\\\"resourceBlock\\\":\\\"S3\\\"}\" \n} \n \nSample Request Body for CSC S3 Bucket Catalog Order: \n \n{\"StackName\":\"sa02292143\",\"CloudAccount\":\"AWS\",\"Location\":\"AWS Datacenter - us-east-1\",\"resourceId\":\"df8c61e3eb2cc210d298fbbdbad0cd74\",\"operationName\":\"Deprovision\",\"resourceInterface\":\"S3 Interface\",\"resourceBlock\":\"S3\"}\n```\n\n## Cloud Services Catalog - POST /now/cmp\\_catalog\\_api/submitrequest\n\nSubmits a cloud services request. This method accepts provisioned requests for both day 2 operations and stacks or resource operation catalog items.\n\n### URL format\n\nDefault URL: `/api/now/cmp_catalog_api/submitrequest`\n\n### Supported request parameters\n\n|Name|Description|\n|----|-----------|\n|None| |\n\n<table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ncat\\_id\n\n</td><td>\n\nRequired. sys\\_id of the cloud catalog item to invoke. Available in the Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\] table.Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_request_body\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nCloudAccount\n\n</td><td>\n\nRequired. Name of the cloud account in which to submit the request. Account names are available in the Cloud Account \\[cmdb\\_ci\\_cmp\\_cloud\\_account\\] table.Data type: String\n\n</td></tr><tr><td>\n\nLocation\n\n</td><td>\n\nRequired. Datacenter location in which to provision the resource. For example, `us-west-1` or `asia-south-2`. This value should match the datacenter location of the cloud account's platform provider. Available in the Associated Datacenter \\[sn\\_cmp\\_ca\\_assc\\_datacenter\\] table. Data type: String\n\n</td></tr><tr><td>\n\nStackName\n\n</td><td>\n\nRequired. Name of the stack. The stack name is dynamic and is reflected in resource management.Data type: String\n\n</td></tr></tbody>\n</table>### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|401|Unauthorized. The user credentials are incorrect or have not been passed.|\n|403|Forbidden. The user doesn't have access rights to the specified record.|\n|404|Not found. The requested item wasn't found.|\n|405|Invalid method. The functionality is disabled.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters \\(JSON or XML\\)\n\n<table id=\"table_m3n_ndj_1bc\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nassignmentGroup\n\n</td><td>\n\nGroup assigned to the request.Data type: String\n\n</td></tr><tr><td>\n\nassignedTo\n\n</td><td>\n\nUser email assigned to the request.Data type: String\n\n</td></tr><tr><td>\n\ncatItem\n\n</td><td>\n\nSys\\_id of the catalog item request.Data type: String\n\nTable: Cloud Catalog Item \\[sn\\_cmp\\_bp\\_cat\\_item\\]\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique Request Item Number \\(RITM\\) given to the new request item.Data type: String\n\nTable: Request Item \\[sc\\_req\\_item\\]\n\n</td></tr><tr><td>\n\nopenedAt\n\n</td><td>\n\nTime stamp from when the request item was opened. Format: yyyy-MM-dd HH:mm:ss.\n\nDate type: String\n\n</td></tr><tr><td>\n\nopenedBy\n\n</td><td>\n\nSys\\_id of the user who opened the request.Data type: String\n\n</td></tr><tr><td>\n\nstage\n\n</td><td>\n\nCurrent processing stage of the request item. Possible values:\n\n-   Deploying Stack\n-   Deployment Cancelled\n-   Deployment Failed\n-   Deployment Successful\n-   Resource Limit Exceeded\n-   Retrying Stack Deployment\n-   Task Created for User\n-   Waiting for Provision Approval\n\nData type: String\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nCurrent completion state of the request item.Possible values:\n\n-   Closed Complete\n-   Closed Incomplete\n-   Closed Skipped\n-   Open\n-   Pending\n-   Work in Progress\n\nData type: String\n\n</td></tr><tr><td>\n\nsubmissionData\n\n</td><td>\n\nInformation about the request submission, like cloud account, location, application, and cost center data. Submission data varies depending on the request item number passed in the request.Data type: Object\n\n```\n\"submissionData\": \"{\\\"key1\\\":\\\"value\\\", \\\"key2\\\":\\\"value\\\"}\"\n}\n```\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the request item record.Data type: String\n\nTable: Request Item \\[sc\\_req\\_item\\]\n\n</td></tr></tbody>\n</table>The following example submits a cloud resource request in the instance's AWS Cloud Account.\n\n```\ncurl \"https://instance.servicenow.com/api/now/cmp_catalog_api/submitrequest?cat_id=022e3deec3122910a769f44ed40131b9\" /\n--request POST \\ \n--header 'Accept: application/json' \\ \n--user 'username':'password'\n\n//Request body:\n{\"CloudAccount\":\"AWS\",\"Location\":\"us-east-1\",\"StackName\":\"ss\"}\n```\n\nResponse:\n\n```\n{ \n  \"number\": \"RITM0010001\", \n  \"catItem\": \"022e3deec3122910a769f44ed40131b9\", \n  \"stage\": \"check_permissions\", \n  \"sys_id\": \"86d34233c3594610bc89b336050131dd\", \n  \"assignedTo\": null, \n  \"assignmentGroup\": null, \n  \"openedAt\": \"2024-04-08 08:59:25\", \n  \"openedBy\": \"6816f79cc0a8016401c5a33be04be441\", \n  \"state\": \"Open\", \n  \"submissionData\": \"{\\\"CloudAccount\\\":\\\"AWS\\\",\\\"Location\\\":\\\"us-east-1\\\",\\\"StackName\\\":\\\"ss\\\"}\" \n}\n```\n\n"}}